<template>
  <!-- <h1>{{title}}</h1> -->
  <div v-if="showModal">
    <Modal @close="loadModal" :header="header">
      <template v-slot:forma>
        <form @submit.prevent="adduser" v-on:keyup.enter="adduser">
          <label>Full Name:</label>
          <input type="text" required v-model="fullname">

          <label>Date of Birth:</label>
          <input type="date" required v-model="doB">

          <label>Email:</label>
          <input type="email" required v-model="email">
          
          <label>City:</label>
      
          <select v-model="city">
            <option v-for="city in cities" :key="city">{{city}}</option>
          </select>
          
          <label>Address:</label>
          <input type="text" required v-model="address">

          <div class="submit">
            <button>Create user</button>
          </div>
          
        </form>
      </template>
    </Modal>
  </div>
  
  <div v-if="editModal">
    <Modal  @close="loadeditModal" :editheader="editheader">
     <template v-slot:forma>
        <form @submit.prevent="edituser(this.indexi)" v-on:keyup.enter="edituser">

          <label>Full Name:</label>
          <input type="text" required v-model="this.user[indexi].fullname">

          <label>Date of Birth:</label>
          <input type="date" required v-model="this.user[indexi].doB">

          <label>Email:</label>
          <input type="email" required v-model="this.user[indexi].email">
          
          <label>City:</label>
      
          <select v-model="this.user[indexi].city">
              <option disabled value="">{{this.user[indexi].city}}</option>
            <option v-for="city in cities" :key="city">{{city}}</option>
          </select>
          
          <label>Address:</label>
          <input type="text" required v-model="this.user[indexi].address">

          <div class="submit">
            <button>Edit user</button>
          </div>
        </form>
      </template>
    </Modal>
  </div>

  <div v-if="deleteModal">
    <Modal  @close="loadDeleteModal" :deleteheader="deleteheader" theme="deleteItem">
     <template v-slot:forma>
        Are you sure you want to delete this item?
        <form @submit.prevent="removeUser(this.indexi)" >
          

          <div class="submit">
            <button @click="loadDeleteModal">No</button>
            <button class="dbutton">Yes</button>
          </div>
        </form>
      </template>
    </Modal>
  </div>

  <div class="container">
    <button class="addbutton" @click="loadModal">Add user</button>
    <table>
      <thead>
        <tr>
          <th>Id</th>
          <th>Full name</th>
          <th>Date of Birth</th>
          <th>Email</th>
          <th>City</th>
          <th>Address</th>
          <th>Edit</th>
          <th>Delete</th>
        </tr>
      </thead>
      <tbody>
        <tr  v-for="(item, index) in user" :key="item">
        <td>{{index+1}}</td>
        <td>{{item.fullname}}</td>
        <td>{{item.doB}} </td>
        <td>{{item.email}}</td>
        <td>{{item.city}}</td>
        <td>{{item.address}}</td>
        <td><button @click="loadeditModal(index)"><i class="fa fa-edit" style="font-size:20px ;color:#696969"></i></button></td>
        <td><button @click="loadDeleteModal(index)"><i class="fa fa-trash" style="font-size:20px; color:#B22222"></i></button></td>
      </tr>

      </tbody>
      
      
    </table>
      

    
   
  </div>


  

</template>

<script>
import Modal from './components/Modal.vue'

export default {
  name: 'App',
  components : {
    Modal
  },
  data (){
    return {
      title: 'My first vue app',
      showModal : false,
      header: "Add user",
      editheader: "Edit user", 
      deleteheader: "Remove user",
      editModal : false,
      deleteModal:false,
      cities : ['Gjilan','Prishtine','Gjakove','Mitrovice','Ferizaj','Prizren','Peje'],
      city: '',
      fullname:'',
      doB:'',
      email:'',
      address : '',
      user:[],
      newname:'',
      newdoB:'',
      newemail:'',
      newcity:'',
      newaddress:'',
      indexi : ''

    }
  },
  created(){
    if(localStorage.getItem('user')){
      this.user = JSON.parse(localStorage.getItem('user'));
    }
  },
  methods:{
    loadModal (){
      this.showModal = !this.showModal;
    },
    
    loadeditModal (index){
      this.editModal = !this.editModal;
      this.indexi = index;
      
      
    },
    loadDeleteModal (index){
      this.deleteModal = !this.deleteModal;
      this.indexi = index;
      
      
    },
    adduser(){
      if (!this.fullname || !this.doB || !this.email || !this.address ||  !this.city) {
        return;
      }
      this.user.push({fullname : this.fullname, doB: this.doB, email: this.email, city: this.city, address : this.address});
      this.city= '',
      this.fullname='',
      this.doB='',
      this.email='',
      this.address = '',
      this.saveUsers();
    },
    saveUsers(){
      const parsed = JSON.stringify(this.user);
      localStorage.setItem('user',parsed);
    },
    edituser(indexi){
      this.newname = this.user[indexi].fullname;
      this.newcity= this.user[indexi].city,
      this.newdoB=this.user[indexi].doB,
      this.newemail=this.user[indexi].email,
      this.newaddress = this.user[indexi].address,
      
      this.user[indexi]= {fullname : this.newname, doB: this.newdoB, email: this.newemail, city: this.newcity, address : this.newaddress };
      // console.log(this.user);
      // this.newcity= '',
      // this.newname='',
      // this.newdoB='',
      // this.newemail='',
      // this.newaddress = '',
      localStorage.setItem('user',JSON.stringify(this.user));

      this.loadeditModal();
    },
    removeUser(indexi){
      this.user.splice(indexi,1);
      localStorage.setItem('user',JSON.stringify(this.user));

    }
  }
  
}
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
form{
  text-align: left;
  margin: 30px auto;
  padding: 30px;
}
label{
  display: inline-block;
  font-size: 0.7em;
  margin: 15px 0px 10px;
  letter-spacing: 1px;
  font-weight: bold;
  color: #aeaeae;
  text-transform: uppercase;
}
input,select{
  display: block;
  padding:10px 6px;
  width: 100%;
  box-sizing: border-box;
  border:none;
  border-bottom : 1px solid #adadad;
  outline: none;
  color: grey;
}
.submit button{
  background: rgb(127, 96, 150);
  border:0;
  padding: 10px 20px;
  color:white;
  border-radius:20px;
  outline: none;
  margin-top: 30px;
  
  
}
button{
  /* border: 1px solid rgba(184, 180, 184, 0.867); */
  /* padding: 5px 10px; */
  border: none;
  background-color: white;
  outline: none;
}
.addbutton{

  padding: 8px 16px;
  font-size: 14px;
  font-weight: bold;
  color:white;

  background-color: #6b0f1a;
  background-image: linear-gradient(315deg, #6b0f1a 0%, #b91372 74%);

  border-radius:10px ;
}
.submit{
  text-align:center;
}
table{
  margin: 20px auto;
  text-align: left;
  border-radius: 0.8em;
  border-collapse:collapse;
  overflow: hidden;
  box-shadow: 0 5px 10px #e4e4e4;
  
}

th {
  padding: 12px;
  padding:1rem 2rem;

  
  font-family:'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
  color: #9760a5e0;
  
  
}
td{
  padding: 12px;
  padding:1rem 2rem;
  border-bottom: 1px solid rgba(226, 220, 220, 0.836);;
  
  font-family:'Segoe UI', Tahoma, Geneva, Verdana, sans-serif;
  color: #888888;
  

}
thead{
  letter-spacing: 1px;
  background-color: white;
  box-shadow: 0 5px 10px #e4e4e4;
  color:rgba(72, 36, 109);
  border:none;
  background-color: #f5f5f5;
  
}

tr:hover {
  background-color: #fdfdfd;
}

.dbutton{
  background: crimson  !important;
  margin-left : 10px;
}
</style>
